org.apache.hc.core5.http.nio.support

## Class BasicResponseConsumer<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicResponseConsumer<T>

- Type Parameters:
    `T` - The message body type.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncResponseConsumer<Message<HttpResponse,T>>, ResourceHolder

      public class BasicResponseConsumer<T>
      extends Object
      implements AsyncResponseConsumer<Message<HttpResponse,T>>

  Basic implementation of `AsyncResponseConsumer` that represents response message as a `Message` and relies on a `AsyncEntityConsumer` to process response entity stream.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicResponseConsumer(AsyncEntityConsumer<T> dataConsumer)`
    `BasicResponseConsumer(Supplier<AsyncEntityConsumer<T>> dataConsumerSupplier)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeResponse(HttpResponse response, EntityDetails entityDetails, HttpContext httpContext, FutureCallback<Message<HttpResponse,T>> resultCallback)` Triggered to signal receipt of a response message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `informationResponse(HttpResponse response, HttpContext httpContext)` Triggered to signal receipt of an intermediate (1xx) HTTP response.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicResponseConsumer

          public BasicResponseConsumer(Supplier<AsyncEntityConsumer<T>> dataConsumerSupplier)

    - #### BasicResponseConsumer

          public BasicResponseConsumer(AsyncEntityConsumer<T> dataConsumer)

  - ### Method Detail

    - #### consumeResponse

          public void consumeResponse(HttpResponse response,
                                      EntityDetails entityDetails,
                                      HttpContext httpContext,
                                      FutureCallback<Message<HttpResponse,T>> resultCallback)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal receipt of a response message head.
      Specified by:
        `consumeResponse` in interface `AsyncResponseConsumer<Message<HttpResponse,T>>`
      Parameters:
        `response` - the response message head.
        `entityDetails` - the response entity details or `null` if the response does not enclose an entity.
        `httpContext` - the actual execution context.
        `resultCallback` - the result callback called when response processing has been completed successfully or unsuccessfully.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### informationResponse

          public void informationResponse(HttpResponse response,
                                          HttpContext httpContext)
                                   throws HttpException,
                                          IOException

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal receipt of an intermediate (1xx) HTTP response.
      Specified by:
        `informationResponse` in interface `AsyncResponseConsumer<Message<HttpResponse,T>>`
      Parameters:
        `response` - the intermediate (1xx) HTTP response.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)
                         throws HttpException,
                                IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncResponseConsumer<Message<HttpResponse,T>>`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.